apiVersion: apps/v1
kind: DaemonSet
metadata:
  labels:
    app: {{ template "stargz-snapshotter.name" . }}
    chart: {{ template "stargz-snapshotter.chart" . }}
    heritage: {{ .Release.Service }}
    release: {{ .Release.Name }}
  name: {{ include "stargz-snapshotter.fullname" . }}
spec:
  selector:
    matchLabels:
      app: {{ template "stargz-snapshotter.name" . }}
      release: {{ .Release.Name }}
  template:
    metadata:
      labels:
        app: {{ template "stargz-snapshotter.name" . }}
        release: {{ .Release.Name }}
    spec:
    {{- if .Values.nodeSelector }}
      nodeSelector:
{{ toYaml .Values.nodeSelector | indent 8 }}
    {{- end }}
      tolerations:
      - effect: NoSchedule
        operator: Exists
      - key: CriticalAddonsOnly
        operator: Exists
      - effect: NoExecute
        operator: Exists
      hostPID: true
      hostNetwork: true
      dnsPolicy: ClusterFirstWithHostNet
      securityContext:
        seLinuxOptions:
          type: "spc_t"
        runAsUser: 0
        fsGroup: 0
      volumes:
      - name: host-etc
        hostPath:
          path: /etc
      - name: host-run
        hostPath:
          path: /run
      - name: host-var
        hostPath:
          path: /var
      - name: host-usr-local-bin
        hostPath:
          path: /usr/local/bin
      - name: config
        configMap:
          name: {{ include "stargz-snapshotter.fullname" . }}
      containers:
      - name: stargz-snapshotter
        image: {{ .Values.image.repository }}:{{ .Values.image.tag }}
        imagePullPolicy: {{ .Values.image.pullPolicy }}
        securityContext:
          privileged: true
          runAsUser: 0
          runAsGroup: 0
          allowPrivilegeEscalation: true
          capabilities:
            add: ["SYS_ADMIN"]
        env:
        - name: "SYSTEMD_IGNORE_CHROOT"
          value: "1"
        command:
        - /bin/bash
        - /opt/cci/run.sh
        volumeMounts:
        - name: host-etc
          mountPath: /etc
        - name: host-run
          mountPath: /run
        - name: host-var
          mountPath: /var
        - name: host-usr-local-bin
          mountPath: /hostfs/usr/local/bin
        - name: config
          mountPath: /opt/cci
